/*
 * Author l0gic aka alu (jan _at_ das _minus_ labor _dot_ org)
 * License: GPLv3
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/user.h>
#include <sys/ptrace.h>
#include <sys/wait.h>

#define DR_OFFSET(dr) ((int)((((struct user *)0)->u_debugreg) + (dr)))

void foo(void) {
  printf("No breakpoint detected.\n");
}

int main(void) {
  int i, status, dr;
  pid_t ppid, childpid;

  if ((*(volatile unsigned *)((unsigned)foo) & 0xFF) == 0xCC) {
    printf("Breakpoint detected (r1, soft)... Exiting now!\n");
    return 1;
  }

  if ((*(volatile unsigned *)((unsigned)foo+6) & 0xFF) == 0xCC) {
    printf("Breakpoint detected (gdb, soft)... Exiting now!\n");
    return 1;
  }

  printf("My PID is: %d\n", getpid());
  childpid = fork();
  if(childpid == 0) {
    ppid = getppid();
    ptrace(PTRACE_ATTACH, ppid, 0, 0);
    wait(&status);
    printf("PID %d attached to PPID %d\n", getpid(), ppid);
    for(i = 0; i <= 3; i++) {
      dr = ptrace(PTRACE_PEEKUSER, ppid, DR_OFFSET(i), 0);
      printf("DR[%d]: %#08X\n", i, dr);
      if(dr != 0) {
        printf("Breakpoint detected (hard)... Exiting now!\n");
        ptrace(PTRACE_KILL, ppid, 0);
        kill(ppid, SIGKILL);
        return 1;
      }
    }
    ptrace(PTRACE_DETACH, ppid, 0);
    return 12;
  } else {
    while(waitpid(childpid, &status, WNOHANG) == 0)
      sleep(1);
    foo();
  }

  return 0;
}
